#ifndef _IRCD_H_

#define _IRCD_H_

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>
#include <netdb.h>
#include <dlfcn.h>
#include <sys/resource.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <errno.h>
#include <limits.h>
#include "chunkyircd.h"

/* should be about 1/3 of the ping time */
#define SELECT_SECS 10

/* Wrapper round fd's */
struct fd_wrap {
    ClientInfo client;
    ServerInfo server;
    TempInfo temp;
    int is_binded;
    int use_ssl;
    int res_id;
};


/* each fd has a structure like this assigned to it */
/* if one is in use, the other is NULL */
/* Main entry point */
int serve_clients(struct bind_info server_sockets[]);
/* For manipulating the fd list */
void ircd_fdlist_clear_entry(int is_highest_fd);
struct fd_wrap *ircd_fdlist_get_entry(int fd);
int ircd_fdlist_set_entry(int fd, struct fd_wrap *contents);

#endif
